## Description

Demonstrates the use of the ADC by continuously monitoring ADC input channel 0-3.  Vary the voltage on the AIN0 input (0 to 0.9V) to observe different readings from the ADC.  

High and low limits are set arbitrarily to demonstrate the detection of overvoltage and undervoltage conditions respectively.  If the ADC reading exceeds 0x300, the example will report that the high limit has been reached.  If the ADC reading falls below 0x25, the example will report the low limit has been reached.

Any reading that exceeds the full-scale value of the ADC will have an '*' appended to the value.

## Required Connections

-   Connect a USB cable between the PC and the CN2 (USB/PWR) connector.
-   Open an terminal application on the PC and connect to the EV kit's console UART at 115200, 8-N-1.

## Expected Output

The Console UART of the device will output these messages:

```
ADC Example
0: 0x0016  2: 0x0001
1: 0x0040  3: 0x001a

0: 0x0001  2: 0x0001
1: 0x0027  3: 0x0001

0: 0x0001  2: 0x0001
1: 0x0011  3: 0x0001

0: 0x0001  2: 0x0001
1: 0x0001  3: 0x0001

0: 0x0001  2: 0x0001
1: 0x0003  3: 0x0001

```
