       /*******************************************************************************
 * Copyright (C) 2016 Maxim Integrated Products, Inc., All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL MAXIM INTEGRATED BE LIABLE FOR ANY CLAIM, DAMAGES
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name of Maxim Integrated
 * Products, Inc. shall not be used except as stated in the Maxim Integrated
 * Products, Inc. Branding Policy.
 *
 * The mere transfer of this software does not imply any licenses
 * of trade secrets, proprietary technology, copyrights, patents,
 * trademarks, maskwork rights, or any other form of intellectual
 * property whatsoever. Maxim Integrated Products, Inc. retains all
 * ownership rights.
 *
 * $Date: 2018-11-06 14:29:25 -0600 (Tue, 06 Nov 2018) $ 
 * $Revision: 38979 $
 *
 ******************************************************************************/

    .syntax unified
    .arch armv7-m
    .text   
    .thumb
    .thumb_func
    .align 2
    .globl   Backup_Handler
    .type    Backup_Handler %function
Backup_Handler:
    /* Wait for VregB to reach its setpoint */
    LDR     R0, =0x40004400
buck_wait:    
    LDR     R1, [R0, #64]
    LSLS    R1, R1, #30
    BPL.N   buck_wait
    /* Switch back to VcoreB */
    LDR     R0, =0x40006C00
    LDR     R1, [R0, #16]
    BIC.W   R1, R1, #6
    STR     R1, [R0, #16]
    /* Jump to Reset_Handler */
    LDR     R0, =0x4000684C
    LDR     R1, [R0]
    BX      R1
    